/*
 *  Copyright 2025-2026 R3944Realms
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package top.r3944realms.eroticdungeongame.core.compat;

import com.xtracr.realcamera.compat.DisableHelper;
import net.minecraft.resources.ResourceLocation;
import net.minecraftforge.fml.ModList;
import top.r3944realms.eroticdungeongame.EroticDungeon;
import top.r3944realms.eroticdungeongame.api.EroticDungeonGameApi;
import top.r3944realms.lib39.core.compat.ICompat;

public class RealCameraCompat implements ICompat {
    public static RealCameraCompat INSTANCE = new RealCameraCompat();
    public static ResourceLocation ID = EroticDungeon.rl("realcamera");
    public boolean initialize = false;
    @Override
    public void setInitialize(boolean initialize) {
        this.initialize = initialize;
    }

    @Override
    public boolean isInitialized() {
        return initialize;
    }

    @Override
    public ResourceLocation id() {
        return ID;
    }

    @Override
    public boolean isModLoaded() {
        return ModList.get().isLoaded("realcamera");
    }

    @Override
    public void initialize() {
        try {
            runIfPresent(() -> {
                DisableHelper.MAIN_FEATURE.registerOr(EroticDungeonGameApi::isInDevice);
            });
        } catch (Exception ignored) {}
    }
}
